"Hello World" Kotlin Multiplatform Native App
======


1. [Introduction](#1-introduction)

2. [Setting up a Kotlin multiplatform Project](#2-setting-up-a-kotlin-multiplatform-project)\
2.1. [Hands-On Lab](#21-hands-on-lab)


3. [Configure ROOT Project gradle File](#3-configure-root-project-gradle-file)

4. [Shared Module](#4-shared-module)\
4.1 [Configure gradle Modul](#41-configure-gradle-modul)\
4.2 [implement & build](#42-implement-&-build)\
4.3 [Test](#43-test)\
4.4 [Hands-On Lab](#44-hands-on-lab)

5. [Android App](#5-android-app)\
5.1 [Configure gradle Modul](#51-configure-gradle-Modul)\
5.2 [implement & build](#52-implement-&-build)\
5.3 [Test](#53-test)\
5.4 [Hands-On Lab](#54-hands-on-lab)

6. [iOS App](#6-ios-app)\
6.1 [Setup the Project](#61-setup-the-project)\
6.2 [refactor shared build.gradle](#62-refactor-shared-buildgradle)\
6.2.1 [add the iOS target](#621-add-the-ios-target)\
6.2.2 [add the iOS framework creation task](#622-add-the-ios-framework-creation-task)\
6.2.3 [build the shared.framework](#623-build-the-sharedframework)\
6.3 [import the shared.framework](#63-import-the-sharedframework)\
6.3.1 [add new build phase for the iOS platform Build](#631-add-new-build-phase-for-the-ios-platform-build)\
6.3.2 [Enable BitCode](#632-enable-bitCode)\
6.3.3 [Extend framework search path](#633-extend-framework-search-path)\
6.3.4 [add a reference to the shared.framework](#634-add-a-reference-to-the-sharedframework)\
6.4 [Refactor UI class to use Shared Lib](#64-refactor-ui-class-to-use-shared-lib)\
6.5 [test App](#65-test-spp)\
6.5 [Hands-On Lab](#65-hands-on-lab)

7. [JS App](#7-js-app)\
7.1 [Configure gradle Modul](#71-configure-gradle-modul)\
7.2 [implement & build](#72-implement-&-build)\
7.3 [Hands-On Lab](#73-hands-on-lab)

8. [Optional Labs](#8-optional-labs)\
8.1 [Use of expect/actual](#81-use-of-expectactual)\
8.2 [shared.jar in an external Project](#82-sharedjar-in-an-external-project)\
8.3 [Android Target in Shared Modul](#83-android-target-in-shared-modul)


# 1. Introduction

The objective of this lesson is to learn how to create a KMP Project from **scratch** with a minimum usage of GUI Tools to target the 3 platforms ( Android,iOS, Web).
We will stick to the Command Line and Scripts, to undestand better and have full control about the building process.

# 2. Setting up a Kotlin multiplatform Project

![Demo](images/Demo.png)

**Download the template**

* Download the template from:

>https://gitlab.com/mbenhajla/kmp_workshop_docs



* Unzip and cd into the directory
```
cd kmp_workshop_docs/02-code/01-helloworldkmp/02-multiplatform/01-workTemplate/
```

**run gradle init**

* run "gradle init" under the directory **HelloKMP**
```
gradle init
```
* Choose the following Options:

```Select type of project to generate:
  1: basic
Select build script DSL:
  1: Groovy

Project name : HelloKMP

```

**create directory structure**

* to create a directory structure as expected by the Gradle Kotlin plugins execute **createProjectTemplate** batch/sh script, this will create the subfolders:  

* for Windows 

```
createProjectTemplate.bat
```

* for for OSX/Unix Systems 

```
./ createProjectTemplate.sh
```

>Note: on Unix systems use "% chmod 755 createProjectTemplate.sh" to make it executable if needed)


## 2.1 Hands-On Lab

![Uebung](images/Uebung.png)

Setup the project as described above


# 3. Configure ROOT Project gradle File

![Demo](images/Demo.png)

**Start Visual Studio Code**

* Open the "HelloKMP" directory in Visual Code

* Insert the following content in the **build.gradle** file in the **root** directory

```
buildscript {
    //ext block with extra properties
    ext.kotlin_version = '1.3.61'
    ext.compose_version = '0.1.0-dev13'
    // required repo's
    repositories {
        maven { url 'https://plugins.gradle.org/m2' }
        maven { url 'http://dl.bintray.com/kotlin/kotlin-eap' }
        maven { url 'https://dl.bintray.com/jetbrains/kotlin-native-dependencies' }
        maven { url 'https://kotlin.bintray.com/kotlin-js-wrappers/'}
        google()
        jcenter()

    }
    // kotlin native dependencies
    dependencies {
        classpath "com.android.tools.build:gradle:4.2.0-alpha07"
        classpath "org.jetbrains.kotlin:kotlin-gradle-plugin:$kotlin_version"
        //classpath "org.jetbrains.kotlin:kotlin-native-gradle-plugin:$kotlin_native_version"
        // NOTE: Do not place your application dependencies here; they belong
        // in the individual module build.gradle files
    }
}

allprojects {
    repositories {
        google()
        jcenter()
        maven { url 'https://plugins.gradle.org/m2' }
        maven { url 'http://dl.bintray.com/kotlin/kotlin-eap' }
        maven { url 'https://dl.bintray.com/jetbrains/kotlin-native-dependencies' }
        maven { url 'https://kotlin.bintray.com/kotlin-js-wrappers/'}

    }
}
```

* add the following lines in **settings.gradle** in the root project


```
/*
 * This file was generated by the Gradle 'init' task.
 *
 * The settings file is used to specify which projects to include in your build.
 */

rootProject.name = 'HelloKMP'
include ':shared'
include ':androidApp'
include ':jsApp'

```

# 4. Shared Module 
# 4.1 Configure gradle Modul

![Demo](images/Demo.png)

* Insert the following content in the **build.gradle** file in the **shared** directory

```
// Shared Sub-project gradle file
apply plugin: 'kotlin-multiplatform'

repositories {
    mavenCentral()
}

kotlin {
    targets {
        jvm()
    }

    js {
        useCommonJs()
        browser()
        nodejs()
    }

    sourceSets {
        // for common code
        commonMain.dependencies {
            api 'org.jetbrains.kotlin:kotlin-stdlib-common'

        }
      
        jvmMain {
            dependencies {
                implementation kotlin('stdlib')
            }
        }
        jsMain {
            dependencies {
                implementation kotlin('stdlib-js')
            }

        }
    }
}

configurations {
    compileClasspath
}

```

>link Doc: https://kotlinlang.org/docs/reference/mpp-dsl-reference.html#top-level-blocks

# 4.2 implement & build

```
package io.sunnyside.hellokmp

class CommonGreeter {

    fun greet(): String = "Hello from Kmp"

}

```

**build**
* run the gradle build from terminal

```
gradle :shared:build
```

or use wrapped gradle Version
```
./gradlew :shared:build
```

**check the build output for JVM & JS**
* for JVM you should find the output JAR files shared-jvm.jar & shared-metadata.jar under 
```
shared/build/libs 
```


* for JS you should find the output JS files under 

```
build/js 
```

# 4.3 Test

* add this to the **build.gradle** file in the **shared** modul

```
    commonTest {
            dependencies {
                implementation kotlin('test-common')
                implementation kotlin('test-annotations-common')


            }
    }

    jvmTest {
            dependencies {
                implementation kotlin('test')
                implementation "org.jetbrains.kotlin:kotlin-test-junit"
            }
    }

    jsTest {
            dependencies {
                implementation kotlin('test-js')
                }
    }  

```

* under the the **src** folder, add a directory **commonTest** (sibling "commonMain") with a subdirectory **kotlin** as expected by the plugin


* in **Visual Studio Code** add a file  **HelloKMPTest.kt**  under the subdirectory **kotlin**  

* implement a small test  to check the shared code

```
import io.sunnyside.hellokmp.CommonGreeter
import kotlin.test.Test
import kotlin.test.assertEquals


open class HelloKMPTest{

    @Test
    open fun greetKMPTest(){
        val commonGreeter = CommonGreeter()
        assertEquals(
            "Hello from Kmp",
            commonGreeter.greet()
        )
    }

}
```


**build**
* run the gradle build from terminal and the allTests task

```
gradle :shared:build
```

```
gradle :shared:allTests
```

**check the test results**

* under  

```
/shared/build/reports/tests/allTests/classes/HelloKMPTest.html
```

## 4.4 Hands-On Lab

![Uebung](images/Uebung.png)

Configure , implement & test the shared modul as described above


# 5. Android App

## 5.1 Setup the Project

![Demo](images/Demo.png)

> Start **Android IDE** to build and implement the android APP and open the folder with the multiplatform project

```
/kmp_workshop_docs/02-code/01-helloworldkmp/02-multiplatform/01-workTemplate
```

We will adapt the code of the Standalone App to use the shared library

* copy the  contents of the **app directory** of the standalone App to the multiplatform project (build subfolder is not needed, since it is generated)


**from directory:**
```
/01-standalone/android/HelloWorld/app
```

**to KMP project sub-directory**

```
androidApp
```


# 5.1 Configure gradle Modul

## 1) add the shared dependency to the project
in the copied **build.gradle** under the **androidApp** directory , add the dependency to the project(':shared'), as follows: 


```
..

dependencies {
    implementation project(':shared')
    ..
}
```




## 2) add gradle.properties File

To be able to use AndroidX packages and to optimize memory :

* Create a gradle.properties under the **root project** with the following content:

```
org.gradle.jvmargs=-Xmx2048m -Dfile.encoding=UTF-8
android.useAndroidX=true
android.enableJetifier=true
kotlin.code.style=official

```


## 3) add local.properties file 
>**only if missing, normally it is added by the IDE**

To allow gradle to find the Android SDK , we need to add a properties file

* add local.properties file under the **root project** with the following content:

(for mac, replcace XXXX with the correct Path)

```
sdk.dir=/[XXXX]/Library/Android/sdk
```

```example: sdk.dir=/Users/mbenhajla/Library/Android/sdk```


(for Windows)
```
sdk.dir=C\:\\[XXXX]\\Android\\Sdk
```

```example: sdk.dir=C\:\\Users\\mobh\\AppData\\Local\\Android\\Sdk```

## 4) Test the androidApp build

**build**
* run the gradle build from the Android IDE or terminal 

```
gradle :androidApp:build
```

**run tests**
* run allTests task from the Android IDE or terminal 

* if you encouter issues when building with the plugin, it is mostly related to the JDK Version used by gradle

//Set the path to JDK Version 8, in gradle.properties file

**gradle.properties Example with Java Path**
```
org.gradle.jvmargs=-Xmx2048m -Dfile.encoding=UTF-8
android.useAndroidX=true
android.enableJetifier=true
kotlin.code.style=official
#org.gradle.java.home=C\:\\Users\\mobh\\Downloads\\openjdk-8
org.gradle.java.home=C\:\\android-studio\\jre
```

**Start the App Android IDE**

* test the App on the Android Emulator


# 5.2 implement & build

* add import of the CommonGreeter from the shared sub-project

```
import io.sunnyside.hellokmp.CommonGreeter
```
* update the copied code in the **Greeting()** method of the MainActivity class to use the shared sub-project as follows

```

    //Greeting("Android")
    Greeting(CommonGreeter().greet())
   
    ...

   @Composable
    fun Greeting(name: String) {
        Text(text = "$name!")
    }

```

# 5.3 Test

* Start the android APP from the Android IDE, you should see the **greeting** from the common modul greet() method


## 5.4 Hands-On Lab

![Uebung](images/Uebung.png)

Configure , implement & test the Android App as described above

# 6. iOS App

## 6.1 Setup the Project

![Demo](images/Demo.png)

* Copy the iOS Standalone App to the iosApp folder under the multiplatform project


**from directory:**
```
/01-standalone/iOS/HelloWorld
```

**to KMP project sub-directory**

```
iosApp/
```

> Start **Xcode** to open the copied HelloWorld App under the **directory iosApp**



**Test the App**

* test the App on the Simulator


## 6.2 refactor shared build.gradle

### 6.2.1 add the iOS target

* Add the iOS target as follows

```
...
kotlin {
    targets {

        ...

        final def iOSTarget = System.getenv('SDK_NAME')?.startsWith('iphoneos') ? presets.iosArm64 : presets.iosX64

        fromPreset(iOSTarget, 'ios'){
            binaries {
                framework('shared')
            }
        }

 ...      

```

>Note: environment variable SDK_NAME is set by XCode. If this environment variable isn't set (e.g. if we run Gradle from terminal), it creates a target for a simulator.

* by Convention the sourceSet for iOS is: iosMain and for testing  is: iosTest

```

...
iosMain.dependencies {

        }

 ...      

```

* add the following line in **settings.gradle** in the root project


```
...
include ':iosApp'

```


### 6.2.2 add the iOS framework creation task

* Add the following task for iOS packaging in the **gradle.build** file of the **shared** modul, this will create a binary framework **shared.framework**, which can be imported and linked in the iOS Project

```
task packForXCode(type: Sync) {
    final File frameworkDir = new File(buildDir, "xcode-frameworks")
    final String mode = project.findProperty("XCODE_CONFIGURATION")?.toUpperCase() ?: 'DEBUG'
    final def framework = kotlin.targets.ios.binaries.getFramework("shared", mode)
    inputs.property "mode", mode
    dependsOn framework.linkTask
    from { framework.outputFile.parentFile }
    into frameworkDir
    doLast {
        new File(frameworkDir, 'gradlew').with {
            text = "#!/bin/bash\nexport 'JAVA_HOME=${System.getProperty("java.home")}'\ncd '${rootProject.rootDir}'\n./gradlew \$@\n"
            setExecutable(true)
        }
    }
}
tasks.build.dependsOn packForXCode

```

### 6.2.3 build the shared.framework

* run the gradle build on the shared task from the IDE
or from terminal

```
gradle :shared:build
```

* you can check the output under:

```/shared/build/xcode-frameworks```


## 6.3 import the shared.framework

### 6.3.1 add new build phase for the iOS platform Build

* In XCode **Build Phases** tab add a new build phase **Run Script Phase**, with  the following script, this will tell gradle to generate the library before generating the XCode project


```
cd "$SRCROOT/../../shared/build/xcode-frameworks"
./gradlew :shared:build -PXCODE_CONFIGURATION=${CONFIGURATION}

```

### 6.3.2 Enable BitCode

* under **Build Settings** set the Flag **Enable Bitcode** to “No”
( Bitcode is an intermediate representation of a compiled program. If it is on Yes, you will not be able to use the **shared framework** in the App)


### 6.3.3 Extend framework search path 

* go to **Framework Search paths** and add a new path (recursive)

```
$(SRCROOT)/../../shared/build/xcode-frameworks
```


### 6.3.4 add a reference to the shared.framework

* under  **General tab**,  add a reference to **shared.framework** under **Embedded Binaries** . the framework should be under ( other Files):

```
../../shared/build/xcode-frameworks
```



## 6.4 Refactor UI class to use Shared Lib

* the generated code for the ContentView should will look like this:

```
import SwiftUI

struct ContentView: View {
    var body: some View {
        Text("Hello, World!")
    }
}
```



* import shared library:


```
import shared
    
```


* refactor ContentView to make use of the shared library:


```

    //return Text("Hello World, Standalone iOS!")
     Text("\(CommonGreeter().greet())")
 

```


## 6.5 test App

* build the App in XCode and run the iOS App on the Simulator. it should display the greeting from the shared modul


## 6.6 Hands-On Lab

![Uebung](images/Uebung.png)

Configure , implement & test the iOS App as described above


# 7. JS App

> You can use either **Visual Studio code** or **Android IDE** to edit and implement the jsAPP

# 7.1 Configure gradle Modul

![Demo](images/Demo.png)

* add the following script in the build.gradle file under jSApp

```


plugins {
    id("org.jetbrains.kotlin.js") 
}


repositories {
    mavenCentral()
    jcenter()
}

dependencies {
    implementation 'org.jetbrains.kotlin:kotlin-stdlib-js'
    implementation project(':shared')

}

kotlin {
    target {
        browser()
        //useCommonJs()
        nodejs()
    }

}

```

# 7.2 implement & build

* add the following code in the empty **main.kt** file under jSApp

```
package io.sunnyside.hellokmp
import  kotlin.browser.document
import org.w3c.dom.HTMLElement

fun main() {
    console.log("start")
    val message = CommonGreeter().greet()
    console.log(message)
    val root = document.getElementById("root")!! as HTMLElement
    root.innerHTML = "<h2>${message}</h2>"

}

```
*  add the following code in the empty **index.html** file

```
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Hallo KMP</title>
    <link rel="stylesheet" href="styles.css">
    <link rel="stylesheet" href="https://unpkg.com/material-components-web@latest/dist/material-components-web.min.css">
    <link href="https://fonts.googleapis.com/css?family=Roboto:300,400,500" rel="stylesheet">
    <meta name="viewport" content="width=device-width, initial-scale=1">


</head>
<body>
<h1>Hello KMP **</h1>
<div id="root"></div>
<script src="jsApp.js"></script>
</body>
</html>
```

*  add the following code in the empty **styles.css** file

```
body {
    font-family: Roboto
}
```

**build**
* run the gradle build from terminal and the allTests task

```
gradle :jsApp:build
```

**Run**

* Run the App in the browser from the IDE 
or 
* Run the App from the terminal :

```
gradle :jsApp:browserRun
```

## 7.3 Hands-On Lab

![Uebung](images/Uebung.png)

Configure , implement & test the JS App as described above

# 8. Optional Labs
## 8.1 Use of expect/actual


**shared**
* adpat the content of CommonGreeter() and add the following line

```
expect fun helloFromPlatform(): String
```

* adapt the greet() method


```
class CommonGreeter {
    fun greet(): String = "Hello KMP from ${helloFromPlatform()}"
}
```

**jvm**
* add an android.kt file with the following implementation:

```
package io.sunnyside.hellokmp

actual fun helloFromPlatform(): String {
    return "JVM"
}
```


**ios**
* add an ios.kt file with the following implementation:

```
package io.sunnyside.hellokmp
import platform.UIKit.UIDevice
actual fun helloFromPlatform(): String {
    return "${UIDevice.currentDevice.systemName()} ${UIDevice.currentDevice.systemVersion()}"
}

```

**js**
* add an js.kt file with the following implementation:

```
package io.sunnyside.hellokmp

//@JsName("helloFromPlatform")  // avoid changing name s with every compilation
//This annotation forces K/JS compiler to use the annotated function  name.
actual fun helloFromPlatform() = "JavaScript"
```

**Update commonTest**

```
import io.sunnyside.hellokmp.CommonGreeter
import kotlin.test.Test
import kotlin.test.assertEquals



open class HelloKMPTest{

    @Test
    open fun greetKMPTest(){
        val commonGreeter = CommonGreeter()
         assertEquals(
            "Hello",
            commonGreeter.greet().substringBefore(" ")
        )
    }

}
```


## 8.2 shared.jar in an external Project

Use the shared.jar in an external Android Project

* Create an Android Project
* Copy the **shared.jar** library ( output of the MPP Project) under a new folder "libs"
* Use the shared.jar in the new Android project


## 8.3 Android Target in Shared Modul

The jvm target which we used until now, will not allow you to use Android API's or resources in your shared library, if you need those in the shared modul, you should add a new target as follows:


* add a new plugin in the top of the shared **build.gradle** as follows: 

```
apply plugin: 'com.android.library'
..
```

* add also a new target for **android** in the shared **build.gradle** under **targets**  as follows:  

```
..
jvm()
android()
..
```


* configure the Android plugin, using the android block in the shared **build.gradle** file as follows:

```
android {
    compileSdkVersion 29
    buildToolsVersion "29.0.3"

    defaultConfig {
        minSdkVersion 28
        versionCode 1
        versionName "1.0"
        testInstrumentationRunner "androidx.test.runner.AndroidJUnitRunner"
    }

    buildTypes {
        release {
            minifyEnabled false
            proguardFiles getDefaultProguardFile('proguard-android.txt'), 'proguard-rules.pro'
        }

        //This is for MultiplatformSettings
        debug {
            // MPP libraries don't currently get this resolution automatically
            matchingFallbacks = ['release']
        }
    }
}
```

 >Note: the classpath for the Android Gradle plugin is already added in the build.gradle of the ROOT project
 classpath ("com.android.tools.build:gradle:4.2.0-alpha07")


* add the sourceSet for the android target in the shared **build.gradle**: 

```
    ..
    androidMain.dependencies {
            implementation kotlin('stdlib')
    }

```

* create a folder **AndroidMain** with a subFolder **kotlin** for the source code


* add content in the in the **AndroidManifest.xml** File:

```
<manifest xmlns:android="http://schemas.android.com/apk/res/android"
    package="io.sunnyside.helloKMP.lib" />
```

**build**
* run the gradle build from terminal and the allTests task

```
gradle :shared:build
```

* The output with the Android artifacts can be found under 

```
build/outputs/aar
```